#include <TH2.h>
#include <TStyle.h>
#include <TCanvas.h>
#include <TPad.h>
#include "TLorentzVector.h"
#include <THistPainter.h>
#include "THStack.h"
#include"TFile.h"
#include "TH1.h"
// put here the include files you need                                                                                                                                             
#include "TStopwatch.h"
#include <iostream>
using namespace std;
#include <iomanip>
#include <fstream>
#include <string>
#include <sstream>
using namespace std;
void Stack_Hist()

{
    double lumi = 300;
    gStyle->SetOptStat(0); //to switch for stat. box
  TString dirname = "/home/ahmed/bb-quark_Signals";
  TString rootH1BB = "h90BP1_bb.root";
  TString rootH2BB= "h90BP2_bb.root";
  TString rootH3BB  = "h95BP1_bb.root";
 TString rootH4BB  = "h95BP3_bb.root";
 TString rootH5BB  = "h96BP1_bb.root";
 TString rootH6BB  = "h96BP2_bb.root";
 TString rootH7BB  = "h96BP3_bb.root";
 TString rootH8BB = "h96BP6_bb.root";

  //TString ps_name = "bb_plots_log.ps";
  TString ps_name = "bb_plots_log.ps";

  rootH1BB=dirname + "/" + rootH1BB;
   rootH2BB=dirname + "/" + rootH2BB;
  rootH3BB=dirname + "/" + rootH3BB;
 rootH4BB =dirname + "/" + rootH4BB ;
rootH5BB =dirname + "/" + rootH5BB ;
rootH6BB =dirname + "/" + rootH6BB ;
rootH7BB =dirname + "/" + rootH7BB ;
rootH8BB =dirname + "/" + rootH8BB ;

  delete gROOT->GetListOfFiles()->FindObject( rootH1BB); 
  delete gROOT->GetListOfFiles()->FindObject( rootH2BB); 
  delete gROOT->GetListOfFiles()->FindObject(rootH3BB); 
  delete gROOT->GetListOfFiles()->FindObject(rootH4BB);
  delete gROOT->GetListOfFiles()->FindObject(rootH5BB);
  delete gROOT->GetListOfFiles()->FindObject(rootH6BB);
  delete gROOT->GetListOfFiles()->FindObject(rootH7BB);
  delete gROOT->GetListOfFiles()->FindObject(rootH8BB);
   
   
  TFile *rootH1BBbar= new TFile(rootH1BB);
  TFile *rootH2BBbar = new TFile(rootH2BB);
  TFile *rootH3BBbar= new TFile(rootH3BB);
  TFile *rootH4BBbar = new TFile(rootH4BB);
  TFile *rootH5BBbar = new TFile(rootH5BB);
  TFile *rootH6BBbar = new TFile(rootH6BB);
  TFile *rootH7BBbar = new TFile(rootH7BB);
  TFile *rootH8BBbar = new TFile(rootH8BB);
  
  
  TH1F *hmc[8][8];TString hname_mc[8];
  hname_mc[0]="b1_pt";
  hname_mc[1]="b1_eta";
  hname_mc[2]="b2_pt";
  hname_mc[3]="b2_eta";
  hname_mc[4]="h_mass";
  hname_mc[5]="h_pt";
  hname_mc[6]="h_eta";
  hname_mc[7]="DR_b";

  double Y_min[8]; double Y_max[8];

 for(int i=0; i<8; i++ ){

    //cout <<"... coloring mc hmc["<<i<<"] " << endl;
     hmc[0][i] = (TH1F*)rootH1BBbar->Get(hname_mc[i]);
     hmc[1][i] = (TH1F*)rootH2BBbar->Get(hname_mc[i]);
     hmc[2][i] = (TH1F*)rootH3BBbar->Get(hname_mc[i]);
     hmc[3][i] = (TH1F*)rootH4BBbar->Get(hname_mc[i]);
     hmc[4][i] = (TH1F*)rootH5BBbar->Get(hname_mc[i]);
     hmc[5][i] = (TH1F*)rootH6BBbar->Get(hname_mc[i]);
     hmc[6][i] = (TH1F*)rootH7BBbar->Get(hname_mc[i]);
     hmc[7][i] = (TH1F*)rootH8BBbar->Get(hname_mc[i]);


  Y_min[i] =(hmc[i][i]->GetMaximum()/1000);
    if(i==1||i==3||i==6)Y_max[i] = 100000*(hmc[2][i]->GetMaximum());
   else if(i==2||i==4||i==7)Y_max[i] = 100000*(hmc[2][i]->GetMaximum());
  else if(i==6)Y_max[i] = 100000*(hmc[2][i]->GetMaximum());
    else Y_max[i] = 100000*(hmc[2][i]->GetMaximum());

     hmc[0][i]->GetYaxis()->SetRangeUser(Y_min[i],Y_max[i]);
     if(i==0||i==2||i==4|| i==5)hmc[0][i]->GetXaxis()->SetRangeUser(0.,400.);
     if(i==1||i==3|| i==6||i==7)hmc[0][i]->GetXaxis()->SetRangeUser(-9.,9.);
     if(i==0||i==2||i==4|| i==5)hmc[1][i]->GetXaxis()->SetRangeUser(0.,400.);
     if(i==1||i==3|| i==6||i==7)hmc[1][i]->GetXaxis()->SetRangeUser(-9.,9.);
     if(i==0||i==2||i==4|| i==5)hmc[2][i]->GetXaxis()->SetRangeUser(0.,400.);
     if(i==1||i==3|| i==6||i==7)hmc[2][i]->GetXaxis()->SetRangeUser(-9.,9.);
     if(i==0||i==2||i==4|| i==5)hmc[3][i]->GetXaxis()->SetRangeUser(0.,400.);
     if(i==1||i==3||i==7)hmc[3][i]->GetXaxis()->SetRangeUser(-9.,9.);
  
  
  
      hmc[0][i]->SetLineColor(kYellow -3);
      hmc[0][i]->SetFillColor(kYellow -3);

      
      hmc[1][i]->SetLineColor(kYellow +3);
      hmc[1][i]->SetFillColor(kYellow +3);
      
      hmc[2][i]->SetLineColor(kBlue -3);
      hmc[2][i]->SetFillColor(kBlue -3);
      
     hmc[3][i]->SetLineColor(kBlue +3);
     hmc[3][i]->SetFillColor(kBlue+3);
  
  
     hmc[4][i]->SetLineColor(kRed -3);
     hmc[4][i]->SetFillColor(kRed -3);
    
     hmc[5][i]->SetLineColor(kRed  +3);
     hmc[5][i]->SetFillColor(kRed  +3);
     
     hmc[6][i]->SetLineColor(kRed  +6);
     hmc[6][i]->SetFillColor(kRed +6);
     
     hmc[7][i]->SetLineColor(kRed  +9);
     hmc[7][i]->SetFillColor(kRed +9);
     
 
     hmc[0][i]->SetMarkerColor(kYellow -3);
     hmc[1][i]->SetMarkerColor( kYellow +3);  
     hmc[2][i]->SetMarkerColor(kBlue -3);  
     hmc[3][i]->SetMarkerColor(kBlue +3);
     hmc[4][i]->SetMarkerColor(kRed -3);
     hmc[5][i]->SetMarkerColor(kRed +3);
     hmc[6][i]->SetMarkerColor(kRed +6);
     hmc[7][i]->SetMarkerColor(kRed+9);

     hmc[0][i]->SetMarkerColor(kYellow -3);  
     hmc[1][i]->SetMarkerColor(kYellow +3);  
     hmc[2][i]->SetMarkerColor(kBlue -3);  
     hmc[3][i]->SetMarkerColor(kBlue +3);
     hmc[4][i]->SetMarkerColor(kRed -3);
     hmc[5][i]->SetMarkerColor(kRed +3); 
     hmc[6][i]->SetMarkerColor(kRed +6);
     hmc[7][i]->SetMarkerColor(kRed +9);


    }//mc for  
    
    cout<<" ...1 "<<endl;
    
  
   
     THStack* t[8];
  
  for(int j=0;j<8;j++)
    { 
      t[j] = new THStack( "Stack_Hist",""); 
                                             
    
   //  printf("0 %d %g\n",j,hmc[0][j]->GetMaximum());
     //   t[j]->Add(hmc[0][j]);
    
    
   //   printf("1 %d %g\n",j,hmc[1][j]->GetMaximum());
     // t[j]->Add(hmc[1][j]);
         
     // printf("2 %d %g\n",j,hmc[2][j]->GetMaximum());
     // t[j]->Add(hmc[2][j]);
     // printf("\n");
}
     
    
     
  
  
  cout<<" ...2 "<<endl;
  //TLegend* legend = new TLegend(0.78,0.835,0.98,0.995);
  
    TLegend* legend = new TLegend(0.7,0.55,0.88,.88,Form("L = %1.1lf fb^{-1}",lumi));
   
   legend->AddEntry( hmc[0][0],"h90BP1_bb ","signal1");//H1BBbar sample
    legend->AddEntry( hmc[1][0],"h90BP2_bb","signal2");//H2BBbar sample
    legend->AddEntry( hmc[2][0],"h95BP1_bb","signal3");//H3BBbar sample
    legend->AddEntry( hmc[3][0],"h95BP3_bb","signal4");//H4BBbar sample
    legend->AddEntry( hmc[4][0],"h96BP1-bb","signal5");//H5BBbar sample
    legend->AddEntry( hmc[5][0],"h96BP2_bb","signal6");//H6BBbar sample
    legend->AddEntry( hmc[6][0],"h96BP3_bb","signal7");//H7BBbar sample
    legend->AddEntry( hmc[7][0],"h96BP6_bb","signal8");//H8BBbar sample
 
 
 
 
 
 
  legend->SetBorderSize(1.); //no border for legend 
  legend->SetFillColor(0);
  legend->SetHeader("L_{data} = 300 fb^{-1}");

 TPostScript* ps = new TPostScript(ps_name,112);//111 portrait 112 landscape 113 eps
  ps->Range(20.0,20.0);

  TCanvas* C = new TCanvas("Fig","Fig");
  gPad->SetLogy();

 for(int i=0; i<8; i++ ){
     
if(i==1||i)gPad->SetLogy(0);else gPad->SetLogy(0);
    //else gPad->SetLogy();

   hmc[0][i]->Draw();
    gPad->SetLogy(1);
     t[i]->Draw("Hist,same");
      
        hmc[0][i]->Draw("HIST same") ;
        hmc[1][i]->Draw("HIST same") ;
        hmc[2][i]->Draw("HIST same") ;
        hmc[3][i]->Draw("HIST same") ;
        hmc[4][i]->Draw("HIST same") ;
        hmc[5][i]->Draw("HIST same") ;
        hmc[6][i]->Draw("HIST same") ;
        hmc[7][i]->Draw("HIST same") ;
      
      // hmc[3][i]->Draw("HIST same");
    // hmc[3][3]->Draw("same");
     gPad->RedrawAxis();
     /* if(i==174)leg->Draw();
	else*/ legend->Draw();
     C->Update(); 
 }

 ps->Print();
 ps->Close();
 system("ps2pdf bb_plots_log.ps");cout<<" ps converted..."<<endl;
 /////////////////////////////////////////////////////////////////

}
